org.apache.fop.area

## Class Trait

- java.lang.Object
- - org.apache.fop.area.Trait

All Implemented Interfaces:
  Serializable

    public final class Trait
    extends Object
    implements Serializable

Area traits used for rendering. This class represents an area trait that specifies a value for rendering.

See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`static class` `Trait.Background` Background trait structure.
`static class` `Trait.ExternalLink` External Link trait structure
`static class` `Trait.InternalLink` Class for internal link traits.

### Field Summary

Fields
`static Integer` `BACKGROUND` Background trait for an area.
`static Integer` `BLINK` Blinking trait used when rendering inline parent.
`static Integer` `BLOCK_PROGRESSION_DIRECTION` block progression direction trait
`static Integer` `BORDER_AFTER` The border after.
`static Integer` `BORDER_BEFORE` The border before.
`static Integer` `BORDER_END` The border end.
`static Integer` `BORDER_START` The border start.
`static Integer` `COLOR` The current color.
`static Integer` `COLUMN_PROGRESSION_DIRECTION` column progression direction trait
`static Integer` `END_INDENT` The end-indent trait.
`static Integer` `EXTERNAL_LINK` External link.
`static Integer` `FONT` The font triplet for the current font.
`static Integer` `FONT_SIZE` Font size for the current font.
`static Integer` `INLINE_PROGRESSION_DIRECTION` inline progression direction trait
`static Integer` `INTERNAL_LINK` Internal link trait.
`static Integer` `IS_REFERENCE_AREA` The is-reference-area trait.
`static Integer` `IS_VIEWPORT_AREA` The is-viewport-area trait.
`static Integer` `LAYER` For optional content groups.
`static Integer` `LINETHROUGH` Linethrough trait used when rendering inline parent.
`static Integer` `LINETHROUGH_COLOR` Trait for color of linethrough decorations when rendering inline parent.
`static int` `MAX_TRAIT_KEY` Maximum value used by trait keys
`static Integer` `OVERLINE` Overline trait used when rendering inline parent.
`static Integer` `OVERLINE_COLOR` Trait for color of overline decorations when rendering inline parent.
`static Integer` `PADDING_AFTER` The padding after.
`static Integer` `PADDING_BEFORE` The padding before.
`static Integer` `PADDING_END` The padding end.
`static Integer` `PADDING_START` The padding start.
`static Integer` `PROD_ID` The ID of the FO that produced an area.
`static Integer` `SHIFT_DIRECTION` shift direction trait
`static Integer` `SPACE_AFTER` The space-after trait.
`static Integer` `SPACE_BEFORE` The space-before trait.
`static Integer` `SPACE_END` The space end.
`static Integer` `SPACE_START` The space start.
`static Integer` `START_INDENT` The start-indent trait.
`static Integer` `STRUCTURE_TREE_ELEMENT` For navigation in the document structure.
`static Integer` `UNDERLINE` Underline trait used when rendering inline parent.
`static Integer` `UNDERLINE_COLOR` Trait for color of underline decorations when rendering inline parent.
`static Integer` `VISIBILITY` Used to disable the rendering of a Block http://www.w3.org/TR/xsl/#rend-vis
`static Integer` `WRITING_MODE` writing mode trait

### Method Summary

All Methods Static Methods Concrete Methods
`static Class` `getTraitClass(Object traitCode)` Get the data storage class for the trait.
`static String` `getTraitName(Object traitCode)` Get the trait name for a trait code.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### INTERNAL_LINK

    public static final Integer INTERNAL_LINK

Internal link trait. Contains the PageViewport key and the PROD_ID of the target area

#### EXTERNAL_LINK

    public static final Integer EXTERNAL_LINK

External link. A URL link to an external resource.

#### FONT

    public static final Integer FONT

The font triplet for the current font.

#### FONT_SIZE

    public static final Integer FONT_SIZE

Font size for the current font.

#### COLOR

    public static final Integer COLOR

The current color.

#### PROD_ID

    public static final Integer PROD_ID

The ID of the FO that produced an area.

#### BACKGROUND

    public static final Integer BACKGROUND

Background trait for an area.

#### UNDERLINE

    public static final Integer UNDERLINE

Underline trait used when rendering inline parent.

#### OVERLINE

    public static final Integer OVERLINE

Overline trait used when rendering inline parent.

#### LINETHROUGH

    public static final Integer LINETHROUGH

Linethrough trait used when rendering inline parent.

#### BORDER_START

    public static final Integer BORDER_START

The border start.

#### BORDER_END

    public static final Integer BORDER_END

The border end.

#### BORDER_BEFORE

    public static final Integer BORDER_BEFORE

The border before.

#### BORDER_AFTER

    public static final Integer BORDER_AFTER

The border after.

#### PADDING_START

    public static final Integer PADDING_START

The padding start.

#### PADDING_END

    public static final Integer PADDING_END

The padding end.

#### PADDING_BEFORE

    public static final Integer PADDING_BEFORE

The padding before.

#### PADDING_AFTER

    public static final Integer PADDING_AFTER

The padding after.

#### SPACE_START

    public static final Integer SPACE_START

The space start.

#### SPACE_END

    public static final Integer SPACE_END

The space end.

#### START_INDENT

    public static final Integer START_INDENT

The start-indent trait.

#### END_INDENT

    public static final Integer END_INDENT

The end-indent trait.

#### SPACE_BEFORE

    public static final Integer SPACE_BEFORE

The space-before trait.

#### SPACE_AFTER

    public static final Integer SPACE_AFTER

The space-after trait.

#### IS_REFERENCE_AREA

    public static final Integer IS_REFERENCE_AREA

The is-reference-area trait.

#### IS_VIEWPORT_AREA

    public static final Integer IS_VIEWPORT_AREA

The is-viewport-area trait.

#### BLINK

    public static final Integer BLINK

Blinking trait used when rendering inline parent.

#### UNDERLINE_COLOR

    public static final Integer UNDERLINE_COLOR

Trait for color of underline decorations when rendering inline parent.

#### OVERLINE_COLOR

    public static final Integer OVERLINE_COLOR

Trait for color of overline decorations when rendering inline parent.

#### LINETHROUGH_COLOR

    public static final Integer LINETHROUGH_COLOR

Trait for color of linethrough decorations when rendering inline parent.

#### STRUCTURE_TREE_ELEMENT

    public static final Integer STRUCTURE_TREE_ELEMENT

For navigation in the document structure.

#### WRITING_MODE

    public static final Integer WRITING_MODE

writing mode trait

#### INLINE_PROGRESSION_DIRECTION

    public static final Integer INLINE_PROGRESSION_DIRECTION

inline progression direction trait

#### BLOCK_PROGRESSION_DIRECTION

    public static final Integer BLOCK_PROGRESSION_DIRECTION

block progression direction trait

#### COLUMN_PROGRESSION_DIRECTION

    public static final Integer COLUMN_PROGRESSION_DIRECTION

column progression direction trait

#### SHIFT_DIRECTION

    public static final Integer SHIFT_DIRECTION

shift direction trait

#### LAYER

    public static final Integer LAYER

For optional content groups.

#### VISIBILITY

    public static final Integer VISIBILITY

Used to disable the rendering of a Block http://www.w3.org/TR/xsl/#rend-vis

#### MAX_TRAIT_KEY

    public static final int MAX_TRAIT_KEY

Maximum value used by trait keys

See Also:
  Constant Field Values

### Method Detail

#### getTraitName

    public static String getTraitName(Object traitCode)

Get the trait name for a trait code.

Parameters:
  `traitCode` - the trait code to get the name for
Returns:
  the trait name

#### getTraitClass

    public static Class getTraitClass(Object traitCode)

Get the data storage class for the trait.

Parameters:
  `traitCode` - the trait code to lookup
Returns:
  the class type for the trait